import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'jwtson_platform_interface.dart';
/*
 * Dayona
 * Created on Thu Jun 02 2022
 * email : dayonaart@gmail.com
 * Copyright (c) 2022
 */

/// An implementation of [JwtsonPlatform] that uses method channels.
class MethodChannelJwtson extends JwtsonPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('jwtson');

  @override
  Future<String?> generateToken(String? key, String? data) async {
    // final result = await methodChannel
    //     .invokeMethod<String>('generatePayload', <String, dynamic>{'key': key, 'data': data});
    // try {
    //   return result;
    // } catch (e) {
    //   return null;
    // }
  }

  @override
  Future<JwtResult?> decodeJwtToken(String? key, String? data) async {
    // final result = await methodChannel
    //     .invokeMethod<dynamic>('decodeJWT', <String, dynamic>{'key': key, 'data': data});
    // try {
    //   final data = JwtResult.fromJson(Map<String, dynamic>.from(result!));
    //   if (data.expired) {
    //     return JwtResult(data: "token expired");
    //   } else {
    //     return data;
    //   }
    // } catch (e) {
    //   return JwtResult(data: "$e");
    // }
  }
}

class JwtResult {
  dynamic body;
  bool? expired;
  dynamic header;
  String? message;
  JwtResult({
    this.body,
    this.expired,
    this.header,
    this.message,
  });

  factory JwtResult.fromJson(Map<String, dynamic> json) {
    return JwtResult(
        body: json['body'],
        expired: json['exp'] == null
            ? null
            : DateTime.now().add(Duration(milliseconds: json['exp'])).isBefore(DateTime.now()),
        header: json['header'],
        message: json['message'] ?? "Success JWT");
  }

  Map<String, dynamic> toJson() => {
        'body': body,
        'expired': expired,
        'header': header,
        'message': message,
      };
}
